import { Component, OnInit } from '@angular/core';
// 引用FmodeChatCompletion类
import { TestChatCompletion, TestChatMessage } from './class-test-chat-completion';
import { TestRxjsChatCompletion } from './class-rxjs-chat-completion';

@Component({
  selector: 'app-chat',
  templateUrl: './chat.page.html',
  styleUrls: ['./chat.page.scss'],
})
export class ChatPage implements OnInit {
  messageList:Array<TestChatMessage> = []
  userInput:string = ""

  completion:TestChatCompletion
  constructor() { 
    // 测试类：纯fetch读取http event stream数据
    this.completion = new TestChatCompletion(this.messageList)

    // 测试类：rxjs封装的可观察对象
  }

  ngOnInit() {
  }
  sendMessage(){
    this.messageList.push({
      role:"user",
      content: this.userInput
    })
    this.userInput = ""
    
    // this.completion.createCompletionByStream()

    // messageList在competion内部，已经赋予了完整的message
    // 下方暴露出来的可订阅内容，主要是用于关键字过滤，或者其他开发逻辑的续写
    let testChatCompletion = new TestRxjsChatCompletion(this.messageList);
    testChatCompletion.createCompletionByStream().subscribe({
        next: ({ content, cumulativeContent, done }) => {
            console.log(`Content: ${content}`);
            console.log(`Cumulative Content: ${cumulativeContent}`);
            if (done) {
                console.log('Stream completed');
            }
        },
        error: err => console.error(err),
        complete: () => console.log('Observable completed')
    });

  }

}
